// Indicator.cpp : implementation file
//

#include "stdafx.h"
#include "RobotController.h"
#include "Indicator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIndicator

CIndicator::CIndicator()
{
	memset(&mKeyArray, 0, sizeof(TKeyArray));
	mClientBrush.CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
}

CIndicator::~CIndicator()
{
}


BEGIN_MESSAGE_MAP(CIndicator, CStatic)
	//{{AFX_MSG_MAP(CIndicator)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndicator message handlers

void CIndicator::OnPaint() 
{
	CPaintDC dc(this); //   

	CRect Bounds; 
	int	  SizeX, SizeY;
	GetClientRect(Bounds);
	SizeX  = Bounds.Width();
	SizeY  = Bounds.Height();

	//  
	dc.FillRect(CRect(0,0,SizeX,SizeY),&mClientBrush);

	//    
	CPen mkPen(PS_SOLID, 1, RGB(0x60,0x60,0x60));
	dc.SelectObject(&mkPen);

	//   
	CBrush mkBrush(RGB(0xC0,0xC0,0xC0));
	dc.SelectObject(&mkBrush);

	//   
	#define cmkX 12
	#define cmkY 120
	#define cmkH 55
	#define cmkN 8
	#define cmbN 4

	static POINT mkPts1[cmkN] = {
		{ cmkX,        cmkY+cmkH   }, { cmkX+cmkH, cmkY+cmkH   },
		{ cmkX+cmkH,   cmkY        }, { cmkX+cmkH*2, cmkY      },
		{ cmkX+cmkH*2, cmkY+cmkH   }, { cmkX+cmkH*3, cmkY+cmkH },
		{ cmkX+cmkH*3, cmkY+cmkH*2 }, { cmkX, cmkY+cmkH*2      }
	};

	dc.Polygon(mkPts1, cmkN);

	static POINT mkPts2[cmbN] = {
		{ cmkX,        cmkY-cmkH }, { cmkX+cmkH*3, cmkY-cmkH },
		{ cmkX+cmkH*3,   cmkY-cmkH*2 }, { cmkX,      cmkY-cmkH*2 }
	};

	dc.Polygon(mkPts2, cmbN);

	#define cmkSc 8
	static POINT mkPts3[cmbN] = {
		{ cmkX,        cmkY+cmkH*2+cmkSc},  { cmkX+cmkH*3, cmkY+cmkH*2+cmkSc },
		{ cmkX+cmkH*3, cmkY+cmkH*3+cmkSc }, { cmkX,        cmkY+cmkH*3+cmkSc }
	};

	#define cOnBkColor  RGB(0x70,0xFF,0x70)
	#define cOffBkColor RGB(0xA0,0xA0,0xA0)
	CBrush mbBrushOn(cOnBkColor);
	CBrush mbBrushOff(cOffBkColor);

	if(mKeyArray.Key[7]) {
		dc.SelectObject(&mbBrushOn); dc.SetBkColor(cOnBkColor);
	} else { dc.SelectObject(&mbBrushOff); dc.SetBkColor(cOffBkColor); }

	dc.Polygon(mkPts3, cmbN);

	dc.SetTextColor(RGB(0,0,0));
	
	CFont TextFont;
	TextFont.CreatePointFont(87,"Microsoft Sans Serif");
	dc.SelectObject(TextFont);

	dc.TextOut(mkPts3[0].x+25, mkPts3[0].y+20," - /");

	CPen mbPen(PS_SOLID, 1, RGB(0x40,0x40,0x40)); dc.SelectObject(&mbPen);

	//  
	#define cmkS 4
	#define cmkHs (cmkH-cmkS*2)
	
	static POINT mbPtsSt[cmbN] = {
		{ cmkX+cmkS,   cmkY+cmkH+cmkS }, { cmkX+cmkHs+cmkS,   cmkY+cmkH+cmkS },
		{ cmkX+cmkHs+cmkS,   cmkY+cmkHs+cmkH+cmkS }, { cmkX+cmkS,   cmkY+cmkHs+cmkH+cmkS  }
	};

	POINT mbPts[cmbN];
	memcpy(&mbPts, &mbPtsSt, sizeof(POINT)*cmbN);

	#define cmbbN 7
	static POINT mbbPts[cmbbN] = {
		{ 0, 0 }, { cmkH, 0 }, { 0, -cmkH }, { cmkH, cmkH }, {0, -cmkH*3}, {-cmkH, 0}, {-cmkH, 0}
	};

	static char* CmdTitle[cmbbN]  = {
		" ","  "," "," "," ","  "," "
	};

	for(int i=0; i<cmbbN; i++) {
		for(int j=0; j<cmbN; j++) {
			mbPts[j].x += mbbPts[i].x; mbPts[j].y += mbbPts[i].y;
		}

		if(mKeyArray.Key[i]) {
			dc.SelectObject(&mbBrushOn); dc.SetBkColor(cOnBkColor);
		} else { dc.SelectObject(&mbBrushOff); dc.SetBkColor(cOffBkColor); }

		dc.Polygon(mbPts, cmbN);

		dc.TextOut(mbPts[0].x+2, mbPts[0].y+17, CmdTitle[i]);
	}
}

void CIndicator::SetKeyArray(TKeyArray* apKeyArray)
{
	if(memcmp(apKeyArray, &mKeyArray, sizeof(TKeyArray))) {
		mKeyArray = *apKeyArray;

		CRect ClientBounds;
		GetClientRect(ClientBounds);
		RedrawWindow(ClientBounds);
	}
}
